#include "Arduino.h"
#include "Led.h"


//Funcin que define los pines de los LED
int leds(int LED)
{
    int PIN=0;
//Inicializa los pines correspondientes a los LED como salidas

    for(int i=2; i<6; ++i)
        pinMode (i, OUTPUT);
    for(int k=7; k<9; ++k)
        pinMode (k, OUTPUT);
    for(int l=12; l<19; ++l)
        pinMode (l, OUTPUT);


//Convierte el valor numerico del LED por el pin correspondiente
    switch (LED)
    {
        case 1:
            PIN=2;
            break;
        case  2:
            PIN=3;
            break;
        case 3:
            PIN=4;
            break;
        case 4:
            PIN=5;
            break;
        case 5:
            PIN=7;
            break;
        case 6:
            PIN=8;
            break;
        case 7:
            PIN=12;
            break;
        case 8:
            PIN=13;
            break;
        case 9:
            PIN=14;
            break;
        case 10:
            PIN=15;
            break;
        case 11:
            PIN=16;
            break;
        case 12:
            PIN=17;
            break;
        case 13:
            PIN=18;
            break;
    }
    return(PIN);
}

//Funcin que enciende un LED especfico
void LedOn (int LED)
{
        int PIN=leds(LED);
        digitalWrite(PIN, HIGH);
}

//Funcin que apaga un LED especfico

void LedOff (int LED)
{
    int PIN=leds(LED);
    digitalWrite(PIN, LOW);
}


//Funcin que produce un retardo en segundos.

void retardo(int tSegundos)
{
    int tMilisegundos;                  //Variable de tiempo expresada en milisegundos.
    tMilisegundos = tSegundos * (1000); //Conversin de segundos a milisegundos.
    delay(tMilisegundos);               //Funcin que produce un retardo en milisegundos.
}

//Funcin para encender el led.




/*Funcin para hacer parpadear el led:
    - Est encendido un tiempo Ton expresado en segundos.
    - Est apagado un tiempo Toff expresado en segundos.*/

void parpadeo(int led, int Ton, int Toff)
{
    leds(led);
    int TonMilisegundos;                //Variable de tiempo de encendido expresada en milisegundos.
    int ToffMilisegundos;               //Variable de tiempo de apagado expresada en milisegundos.

    TonMilisegundos= Ton * (1000);      //Conversin de Ton de segundos a milisegundos
    ToffMilisegundos = Toff * (1000);   //Conversin de Toff de segundos a milisegundos.

    LedOn(led);                       //Encendido del led con la funcin ledOn.
    delay(TonMilisegundos);             //Retardo de un tiempo Ton expresado en milisegundos.
    LedOff(led);                      //Apagado del led con la funcin ledOff.
    delay(ToffMilisegundos);            //Retardo de un tiempo Toff expresado en milisegundos.
}


// Funcin para manejar el RGB
/*Se sebe introducir un valor entre 0 y 255 para los tres colores
pudiendo combinarse entre s */

void RGB (int R, int G, int B)
{
    int RGB_R=9;
    int RGB_G=10;
    int RGB_B=11;
    pinMode(RGB_R, OUTPUT);
    pinMode(RGB_G, OUTPUT);
    pinMode(RGB_B, OUTPUT);
    analogWrite (RGB_R, R);
    analogWrite (RGB_G, G);
    analogWrite (RGB_B, B);
}

//Funcin para manejar el LDR
/*Lee y devuelve el valor ledo por el sensor*/

int LDR ()
{
    int sensor = A7;
    pinMode (sensor, INPUT);
    int lectura=analogRead (sensor);
    return lectura;
}

//Funcin para manejar el buzzer
/*Se introducen como parmetros de entrada la frecuencia
a la que se desea que suene y el tiempo en segundos que debe sonar*/

void zumbador(int frecuencia, int segundos)
{

    int zumbador = A5;
    int duracion=segundos*1000;
    tone (zumbador, frecuencia, segundos);

}

//Funcin que apaga el buzzer

void zumbadorapagado()
{
    int zumbador = A5;
    noTone(zumbador);
}

//Funcin que devuelve cul de los 5 botones ha sido pulsado
int botonera ()
{

    int adc_KEY_val[5]={20,50,100,200,600};
    int NUM_KEYS=5;
    int adc_key_in;
    int key=1;
    int oldkey=-1;
    int boton;



    adc_key_in=analogRead(A6);
    key=get_key(adc_key_in);
    if(key!=oldkey)
    {
        delay(50);
        adc_key_in=analogRead(A6);
        key=get_key(adc_key_in);
        if(key != oldkey)
        {
            oldkey=key;
            if(key >=0)
            {
                switch(key)
                {
                case 0:
                    boton=1;
                    break;
                case 1:
                    boton=2;
                    break;
                case 2:
                    boton = 3;
                    break;
                case 3:
                    boton = 4;
                    break;
                case 4:
                    boton = 5;
                    break;
                }
            }
        }
    }
return (boton);
}

//Funcin que devuelve si el botn se est pulsando o no
int estado_boton ()
{

    int adc_KEY_val[5]={20,50,100,200,600};
    int NUM_KEYS=5;
    int adc_key_in;
    int key=1;
    int oldkey=-1;
    int boton;
    bool estado=false;



    adc_key_in=analogRead(A6);
    key=get_key(adc_key_in);
    if(key!=oldkey)
    {
        delay(50);
        adc_key_in=analogRead(A6);
        key=get_key(adc_key_in);
        if(key != oldkey)
        {
            oldkey=key;
            if(key >=0)
            {
                switch(key)
                {
                case 0:
                    estado=!estado;
                    break;
                case 1:
                    estado=!estado;
                    break;
                case 2:
                    estado=!estado;
                    break;
                case 3:
                    estado=!estado;
                    break;
                case 4:
                    estado=!estado;
                    break;
                }
            }
        }
    }

return (estado);
}

//Convertir el numeor ADC al numero key
//Se usa en la funcin botonera
int get_key(unsigned int input)
{
    int adc_KEY_val[5]={20,50,100,200,600};
    int NUM_KEYS=5;
    int k;
        for( k=0; k<NUM_KEYS; ++k)
    {
        if (input < adc_KEY_val[k])
        {
            return k;
        }
    }
    if (k >= NUM_KEYS)k=-1;//Boton pulsado no valido
        return k;
}


//Funcin que maneja el relo binario
/*Se introduce como parmetro de entrada la hora en nmeros
decimales separando cada dgito por una hora y la funcin lo
convierte en lenguaje binario y enciende los LED correspondientes*/

void hora(int dh, int uh, int dm, int um)
{
    Serial.println(dh);
    Serial.println(uh);
    Serial.println(dm);
    Serial.println(um);
    int decenas_horas=dh;
    switch (dh)
    {
            case 1:
            LedOn(2);
            break;
        case 2:
            LedOn(1);
            break;
    }
    switch (uh)
    {
        case 1:
            LedOn(6);
            break;
        case 2:
            LedOn(5);
            break;
        case 3:
            LedOn(5);
            LedOn(6);
            break;
        case 4:
            LedOn(4);
            break;
        case 5:
            LedOn(4);
            LedOn(6);
            break;
        case 6:
            LedOn(4);
            LedOn(5);
            break;
        case 7:
            LedOn(4);
            LedOn(5);
            LedOn(6);
            break;
        case 8:
            LedOn(3);
            break;
        case 9:
            LedOn(3);
            LedOn(6);
            break;
    }
     switch (dm)
    {
        case 1:
            LedOn(9);
            break;
        case 2:
            LedOn(8);
            break;
        case 3:
            LedOn(8);
            LedOn(9);
            break;
        case 4:
            LedOn(7);
            break;
        case 5:
            LedOn(7);
            LedOn(9);
            break;
    }
     switch (um)
    {
        case 1:
            LedOn(13);
            break;
        case 2:
            LedOn(12);
            break;
        case 3:
            LedOn(12);
            LedOn(13);
            break;
        case 4:
            LedOn(11);
            break;
        case 5:
            LedOn(11);
            LedOn(13);
            break;
        case 6:
            LedOn(11);
            LedOn(12);
            break;
        case 7:
            LedOn(11);
            LedOn(12);
            LedOn(13);
            break;
        case 8:
            LedOn(10);
            break;
        case 9:
            LedOn(10);
            LedOn(13);
            break;
    }
}

//Funcin que maneja el reloj binario
/*Se introducen como parmetro de entrada los cuatro
vectores correspondientes a las columnas de LED de manera
que el 1 significa que el LED de esa posicin est encendido
y el 0 que est apagado.*/

int reloj (int dh[2], int uh[4], int dm[3], int um[4])
{
int k=4;
int dhd, uhd, dmd, umd;

    for (int i=0; i<3; ++i)
    {
        switch (i)
        {
        case 0:
            if (dh[0]==1)
            LedOn(1);
            break;
        case 1:
            if(dh[1]==1)
            LedOn(2);
            break;
        default:
            LedOff(1);
            LedOff(2);
        }
    }
    for (int j=0; j<5; ++j)
    {
        switch(j)
        {
        case 0:
            if (uh[0]==1)
            LedOn(3);
            break;
        case 1:
            if (uh[1]==1)
            LedOn(4);
            break;
        case 2:
            if (uh[2]==1)
            LedOn(5);
            break;
        case 3:
            if (uh[3]==1)
            LedOn(6);
            break;
        default:
            LedOff(3);
            LedOff(4);
            LedOff(5);
            LedOff(6);

        }
    }
    for (int k=0; k<4; ++k)
    {
        switch (k)
        {
            case 0:
                if(dm[0]==1)
                LedOn(7);
                break;
            case 1:
                if (dm[1]==1)
                LedOn(8);
                break;
            case 2:
                if (dm[2]==1)
                LedOn(9);
                break;
            default:
                LedOff(7);
                LedOff(8);
                LedOff(9);
        }
    }
    for (int l=0; l<5; ++l)
    {
        switch (l)
        {
        case 0:
            if (um[0]==1)
            LedOn(10);
            break;
        case 1:
            if (um[1]==1)
            LedOn(11);
            break;
        case 2:
            if (um[2]==1)
            LedOn(12);
            break;
        case 3:
            if (um[3]==1)
            LedOn(13);
            break;
        default:
            LedOff(10);
            LedOff(11);
            LedOff(12);
            LedOff(13);
        }
    }

}
