#ifndef LED_H_INCLUDED
#define LED_H_INCLUDED

#include "Arduino.h"

/* Declaracin de las cabeceras de las funciones
que forman parte de la librera*/



//Funcin para definir los pines de los LED
//Convierte el valor del LED en el PIN conectado

int leds(int LED);

//Funcin para encender un LED concreto

void LedOn(int LED);

//Funcin para apagar un LED concreto

void LedOff(int LED);

//Funcin que produce un retardo en segundos

void retardo(int tSegundos);

/*Funcin para hacer parpadear el led:
    - Est encendido un tiempo Ton expresado en segundos.
    - Est apagado un tiempo Toff expresado en segundos.*/

void parpadeo(int led, int Ton, int Toff);

//Funcin para modificar los colores del RGB

void RGB(int R, int G, int B);

//Funcin que devuelve el valor leido por el sensor LDR

int LDR ();

//Funcin para hacer sonar el buzzer a una frecuencia concreta

void zumbador (int frecuencia, int segundos);

//Funcin que apaga el buzzer

void zumbadorapagado();

//Funcin que devuelve qu botn se ha pulsado

int botonera();

//Funcin que devuelve si el botn se est pulsando o no

int estado_boton ();

//Convertir el numeor ADC al numero key
//Se usa en la funcin botonera
int get_key(unsigned int input);

//Funciones para el Reloj Binario
/*
    -parmetros de entrada: HORA DECIMAL*/

void hora(int dh, int uh, int dm, int um);

/*
    -parmetros de entrada: HORA EN CDIGO BINARIO*/

int reloj(int dh[], int uh[], int dm[], int um[]);






#endif // LED_H_INCLUDED
